##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 .globl menu_data15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))

PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites/    ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, SET_MASK        , interlaced         )) 

#NIVEL
$(eval $(call IMG2SP, CONVERT , img/cuchara.png, 10, 16, cuchara_sp, cuchara_pal))
$(eval $(call IMG2SP, CONVERT , img/disparo.png, 8, 8, disparo_sp, disparo_pal))
$(eval $(call IMG2SP, CONVERT , img/cucharaEnemy.png, 16, 16, cucharaE_sp, cucharaE_pal))
$(eval $(call IMG2SP, CONVERT , img/disparoEnemy.png, 8, 8, disparoE_sp, disparoE_pal))
$(eval $(call IMG2SP, CONVERT , img/cuchillico.png, 10, 16, cuchillo_sp, cuchillo_pal))

#OBSTACULOS
$(eval $(call IMG2SP, CONVERT , img/Bol.png, 8, 8, bol_sp, bol_pal))
$(eval $(call IMG2SP, CONVERT , img/tostada.png, 8, 8, tostada_sp, tostada_pal))

#WINK
$(eval $(call IMG2SP, CONVERT , img/Guiño.png, 16, 16, guinyo_sp, guinyo_pal))

$(eval $(call IMG2SP, SET_MASK        , none        )) 
#MENU PRINCIPAL
$(eval $(call IMG2SP, CONVERT , img/Title.png, 68, 24, menu_sp, menu_pal))
$(eval $(call IMG2SP, CONVERT , img/Title2.png, 80, 24, menu2_sp, menu2_pal))
$(eval $(call IMG2SP, CONVERT , img/disparoEnemy2.png, 8, 8, disparoE2_sp, disparoE2_pal))
$(eval $(call IMG2SP, CONVERT , img/Jugar.png, 40, 12, jugar_sp, jugar_pal))
$(eval $(call IMG2SP, CONVERT , img/Bonus.png, 40, 12, bonus_sp, bonus_pal))

# HUD
$(eval $(call IMG2SP, CONVERT , img/HUD.png, 32, 32, hud_sp, hud_pal))
$(eval $(call IMG2SP, CONVERT , img/BordeIzq.png, 32, 16, bordeIzq_sp, bordeIzq_pal))
$(eval $(call IMG2SP, CONVERT , img/BordeDer.png, 32, 16, bordeDer_sp, bordeDer_pal))
$(eval $(call IMG2SP, CONVERT , img/carafeliz.png, 16, 16, caraFeliz_sp, caraFeliz_pal))
$(eval $(call IMG2SP, CONVERT , img/carasusto.png, 16, 16, caraSusto_sp, caraSusto_pal))
$(eval $(call IMG2SP, CONVERT , img/vida.png, 8, 10, vida_sp, vida_pal))

#MAPA
PALETTE2=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE2)         ))
$(eval $(call IMG2SP, SET_IMG_FORMAT, zgtiles    ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                 ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE2), palette2 ))
$(eval $(call IMG2SP, CONVERT, img/Tileset8x8.png, 8, 8, tiles, palette2))


##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
