;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Amstrad CPC videogame "Cuchara Voladora"
;;  Copyright (C) 2018 Blue Hornet / Sergio Perez Perez / Borja Garcia Pizarro 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

;;==============================================================
;; FUNCTIONS AND MACROS RELATED WITH ENTITYS
;;==============================================================

.include "render.h.s"

.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _sp, _upd
_name:
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sp	
    .db    _vx, _vy       ;; VX, VY
    .dw    _upd		  ;; Update (dw -> Little Endian)
_name'_size = . - _name
.endm

e_de 		= 0
e_de_size 	= 6
e_vx 		= 0 + e_de_size
e_vy 		= 1 + e_de_size	
e_up_l 	= 2 + e_de_size
e_up_h 	= 3 + e_de_size

.macro DefineEntityDefault _name, _suf

	DefineEntity _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0, 0xFFFF

.endm

.macro DefineNentities _name, _n
	_c = 0
	.rept _n
		DefineEntityDefault _name, \_c
		_c = _c + 1
	.endm
.endm


;; CONSTANTES

.globl ent_draw
.globl ent_drawFixed
.globl ent_update
.globl ent_new
.globl ent_copy
.globl ent_doForAll
.globl ent_move


.globl disparo_data
.globl disparoE_data