;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Amstrad CPC videogame "Cuchara Voladora"
;;  Copyright (C) 2018 Blue Hornet / Sergio Perez Perez / Borja Garcia Pizarro 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

;;==============================================================
;; FUNCTIONS RELATED WITH MENUS
;;==============================================================

;;==============================================================
;; INCLUDE AREA
;;==============================================================

.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"
.include "menu.h.s"
.include "level.h.s"

;.globl _song_ingame
.globl _menu_sp
.globl _menu2_sp
.globl _jugar_sp
.globl _bonus_sp
.globl _hud_sp_0
.globl _hud_sp_1
.globl _hud_sp_2
.globl _bordeIzq_sp
.globl _bordeDer_sp
.globl _caraFeliz_sp
.globl _caraSusto_sp
.globl _vida_sp

.globl _disparoE2_sp
.globl _guinyo_sp


song_ptr             = 0xE10

option: .db #1
unavariable: .db #1

DefineDrawableEntity menu_data, 0x10, 0x15, 0x22, 0x16, _menu_sp
DefineDrawableEntity menu2_data, 0x15, 0x30, 0x28, 0x16, _menu2_sp
DefineDrawableEntity jugar_data, 0x15, 0x60, 0x14, 0x09, _jugar_sp
DefineDrawableEntity bonus_data, 0x15, 0x80, 0x14, 0x09, _bonus_sp

DefineDrawableEntity bordeIzq_data, 0x00, 0x90, 0x10, 0x08, _bordeIzq_sp
DefineDrawableEntity hud_data_init, 0x10, 0x90, 0x10, 0x20, _hud_sp_0
DefineDrawableEntity hud_data_mid, 0x20, 0x90, 0x10, 0x20, _hud_sp_1	
DefineDrawableEntity hud_data_end, 0x30, 0x90, 0x10, 0x20, _hud_sp_2
DefineDrawableEntity bordeDer_data, 0x40, 0x90, 0x10, 0x08, _bordeDer_sp
DefineDrawableEntity hud_data_cara, 0x15, 0x99, 0x08, 0x10, _caraFeliz_sp
DefineDrawableEntity hud_data_vida, 0x32, 0x99, 0x04, 0x08, _vida_sp	
DefineDrawableEntity hud_data_vida2, 0x37, 0x99, 0x04, 0x08, _vida_sp

DefineDrawableEntity punt_data, 0x10, 0x60, 0x04, 0x08, _disparoE2_sp	

DefineDrawableEntity guinyo_data, 0x75, 0x30, 0x08, 0x10, _guinyo_sp	


;;=============================================
;; Change the menu option
;; DESTROYS: IX
;; INPUT: A -> New option
;;=============================================
menu_puntpos:

	ld ix, #punt_data
	
	ld de_y(ix),a

ret

;;=============================================
;; Load the main menu
;; DESTROYS: A, HL
;;=============================================
menu_system:

	call	draw_menu

menu_loop:

	;ld      a, (unavariable)
      ;xor     #1
      ;ld      (unavariable), a
      call     cpct_akp_musicPlay_asm  
      call     cpct_akp_musicPlay_asm
      call     cpct_akp_musicPlay_asm    


	call draw_sprite

	call cpct_scanKeyboard_asm

	;;Change option
	ld	hl, #Key_S
	call	cpct_isKeyPressed_asm
	jr 	z, W_pressed

	ld a,#0
	ld (option),a
	ld a, #0x80
	call menu_puntpos

	jp continue

	W_pressed:
	ld	hl, #Key_W
	call	cpct_isKeyPressed_asm
	jr 	z, continue

	ld a, #1
	ld (option),a
	ld a, #0x60
	call menu_puntpos

	continue:

	;; Press Enter 
	ld	hl, #Key_Return
    	call	cpct_isKeyPressed_asm
    	jr	z, menu_loop

    	call	cpct_akp_stop_asm

    	ld a,(option)
    	cp #1
    	jp z, otro

    	ld	a, #04
    	ld	(CurrentLevel),a

    	ret


    	otro:
    	ld	a, #00
    	ld	(CurrentLevel),a
    	ret


;;=============================================
;; Draw the main menu
;; DESTROYS: DE
;;=============================================
draw_menu:

	;; Put the screen in black
	call black_screen

	;; Initialize music
    	ld      de, #song_ptr
    	call    cpct_akp_musicInit_asm

    	

	ret

;;=============================================
;; Draw a black screen
;; DESTROYS: A, HL, BC, DE
;;=============================================
black_screen:
	call  ren_newScene
	ld hl, #0xC000
	ld a, #0x00
	ld (hl), a
	ld de, #0xC001
	ld bc, #0x4000
	ldir

	ret

;;=============================================
;; Draw all the menu sprites
;; DESTROYS: IX
;;=============================================
draw_sprite:

	call  cpct_waitVSYNC_asm
	call  ren_newScene

	ld ix, #menu_data
	call	ent_drawFixed

	ld ix, #menu2_data
	call	ent_drawFixed

	ld ix, #jugar_data
	call	ent_drawFixed

	ld ix, #bonus_data
	call	ent_drawFixed

	ld ix, #punt_data
	call ent_drawFixed

	ret

;;=============================================
;; Draw all the hud sprites
;; DESTROYS: IX, A
;;=============================================
draw_hud:

	ld ix, #bordeIzq_data
	call  ent_drawFixed

	ld ix, #hud_data_init
	call	ent_drawFixed

	ld ix, #hud_data_mid
	call ent_drawFixed

	ld ix, #hud_data_end
	call ent_drawFixed

	ld ix, #bordeDer_data
	call  ent_drawFixed

	ld ix, #hud_data_cara
	call ent_drawFixed

	ld ix, #hud_data_vida
	call ent_drawFixed

	ld ix, #hud_data_vida2
	ld  a, de_x(ix)
      cp  #0xFF
      ret z

	ld ix, #hud_data_vida2
	call ent_drawFixed

	ret


;;=============================================
;; Change the face of the hero in the hud
;; DESTROYS: IX, HL
;;=============================================
menu_changeFace:

	ld ix, #hud_data_cara
	ld hl, #_caraSusto_sp
      ld  de_sp_l(ix), l
      ld  de_sp_h(ix), h

	ret

;;=============================================
;; Update the life of the hero
;; DESTROYS: IX, A
;;=============================================
menu_updateLife:

	ld ix, #hud_data_vida2
	ld  a, de_x(ix)
      cp  #0xFF
      ret z

      	;; Erase life
      	ld      de_x(ix), #0xFF
    		ld      de_y(ix), #0xFF

	ret